src/AppBundle/Entity/RaidHistory.php
<?php

/*
 * This file is part of the Arnapou GW2Tools package.
 *
 * (c) Arnaud Buathier <arnaud@arnapou.net>
 *
 * For the full copyright and license information, please view the LICENSE
 * file that was distributed with this source code.
 */

namespace AppBundle\Entity;

use Doctrine\ORM\Mapping as ORM;

/**
 * Token
 *
 * @ORM\Table(name="raidhistory", indexes={
 *      @ORM\Index(name="type"          , columns={"type"}    ),
 *      @ORM\Index(name="date_creation" , columns={"date_creation"} )
 * })
 * @ORM\Entity(repositoryClass="AppBundle\Repository\RaidHistoryRepository")
 */
class RaidHistory
{
    const ROSTER_CREATION    = 'roster_creation';
    const OFFICER_PROMOTE    = 'officer_promote';
    const OFFICER_RETROGRADE = 'officer_retrograde';
    const MEMBER_NEW         = 'member_new';
    const MEMBER_LEAVE       = 'member_leave';
    const MEMBER_REMOVE      = 'member_remove';
    const STATUS_CHANGE      = 'status_change';
    const MEMBER_CHANGE_NAME = 'member_change_name';

    /**
     * @ORM\Id
     * @ORM\Column(type="bigint")
     * @ORM\GeneratedValue
     */
    private $id;

    /**
     * @var string
     *
     * @ORM\Column(name="member_name", type="string", length=100)
     */
    private $memberName = '';

    /**
     * @var string
     *
     * @ORM\Column(name="type", type="string", length=100)
     */
    private $type = '';

    /**
     * @var RaidRoster
     *
     * @ORM\ManyToOne(targetEntity="AppBundle\Entity\RaidRoster")
     * @ORM\JoinColumn(name="roster_id", referencedColumnName="id", onDelete="CASCADE")
     */
    private $roster;

    /**
     * @var string
     *
     * @ORM\Column(name="data", type="text")
     */
    private $data = '';

    /**
     * @var int
     *
     * @ORM\Column(name="date_creation", type="integer")
     */
    private $dateCreation;

    public function __construct()
    {
        $this->dateCreation = time();
    }

    /**
     * @return mixed
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * @return string
     */
    public function getType()
    {
        return $this->type;
    }

    /**
     * @param string $type
     */
    public function setType($type)
    {
        $this->type = $type;
    }

    /**
     * @return RaidRoster
     */
    public function getRoster()
    {
        return $this->roster;
    }

    /**
     * @param RaidRoster $roster
     */
    public function setRoster(RaidRoster $roster)
    {
        $this->roster = $roster;
    }

    /**
     * @return array
     */
    public function getDataTrans()
    {
        $trans = [
            '%member%' => $this->getMemberName(),
        ];
        foreach ($this->getData() as $key => $value) {
            $trans['%' . $key . '%'] = $value;
        }
        return $trans;
    }

    /**
     * @return array
     */
    public function getData()
    {
        if ($this->data) {
            return unserialize($this->data);
        }
        return [];
    }

    /**
     * @param string $data
     */
    public function setData($data)
    {
        $this->data = !empty($data) && \is_array($data) ? serialize($data) : '';
    }

    /**
     * @return int
     */
    public function getDateCreation()
    {
        return $this->dateCreation;
    }

    /**
     * @param int $dateCreation
     */
    public function setDateCreation($dateCreation)
    {
        $this->dateCreation = $dateCreation;
    }

    /**
     * @return string
     */
    public function getMemberName()
    {
        return $this->memberName;
    }

    /**
     * @param string $name
     */
    public function setMemberName($name)
    {
        $this->memberName = $name;
    }
}

src/AppBundle/Entity/RaidMember.php
<?php

/*
 * This file is part of the Arnapou GW2Tools package.
 *
 * (c) Arnaud Buathier <arnaud@arnapou.net>
 *
 * For the full copyright and license information, please view the LICENSE
 * file that was distributed with this source code.
 */

namespace AppBundle\Entity;

use Arnapou\GW2Api\Model\Character;
use Arnapou\GW2Api\Model\InventorySlot;
use Arnapou\GW2Api\Model\Item;
use Doctrine\ORM\Mapping as ORM;
use Gw2tool\Account;

/**
 * Token
 *
 * @ORM\Table(name="raidmember", indexes={
 *      @ORM\Index(name="name"          , columns={"name"}    ),
 *      @ORM\Index(name="date_creation" , columns={"date_creation"} )
 * })
 * @ORM\Entity(repositoryClass="AppBundle\Repository\RaidMemberRepository")
 */
class RaidMember
{
    const MEMBER    = '';
    const ALLY      = 'ally';
    const OFFICER   = 'officer';
    const CHECK_DELAY = 900;

    /**
     * @ORM\Id
     * @ORM\Column(type="bigint")
     * @ORM\GeneratedValue
     */
    private $id;

    /**
     * @var string
     *
     * @ORM\Column(name="name", type="string", length=100)
     */
    private $name = '';

    /**
     * @var RaidRoster
     *
     * @ORM\ManyToOne(targetEntity="AppBundle\Entity\RaidRoster")
     * @ORM\JoinColumn(name="roster_id", referencedColumnName="id", onDelete="CASCADE")
     */
    private $roster;

    /**
     * @var string
     *
     * @ORM\Column(name="text", type="string", length=200)
     */
    private $text = '';

    /**
     * @var string
     *
     * @ORM\Column(name="status", type="string", length=10)
     */
    private $status = self::MEMBER;

    /**
     * @var int
     *
     * @ORM\Column(name="date_creation", type="integer")
     */
    private $dateCreation;

    /**
     * @var string
     *
     * @ORM\Column(name="data", type="text")
     */
    private $data = '';

    public function __construct()
    {
        $this->dateCreation = time();
    }

    /**
     * @return mixed
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * @return array
     */
    public function getNameParts()
    {
        if (\preg_match('!^(.+)\.([0-9]+)$!', $this->name, $m)) {
            return [$m[1], $m[2]];
        }
        return [$this->name, ''];
    }

    /**
     * @param string $name
     */
    public function setName($name)
    {
        $this->name = $name;
    }

    /**
     * @return bool
     */
    public function hasData()
    {
        return !empty($this->data);
    }

    /**
     * @return array
     */
    public function getData()
    {
        if ($this->data) {
            return unserialize($this->data);
        }
        return [];
    }

    /**
     * @param array $data
     */
    public function setData($data)
    {
        $this->data = !empty($data) && \is_array($data) ? serialize($data) : '';
    }

    /**
     * @return RaidRoster
     */
    public function getRoster()
    {
        return $this->roster;
    }

    /**
     * @param RaidRoster $roster
     */
    public function setRoster($roster)
    {
        $this->roster = $roster;
    }

    /**
     * @return string
     */
    public function getText()
    {
        return $this->text;
    }

    /**
     * @param string $text
     */
    public function setText($text)
    {
        $this->text = $text;
    }

    /**
     * @return bool
     */
    public function isCreator()
    {
        return $this->name === $this->getRoster()->getCreator();
    }

    /**
     * @return bool
     */
    public function isOfficer()
    {
        return $this->status === self::OFFICER;
    }

    /**
     * @return bool
     */
    public function isAlly()
    {
        return $this->status === self::ALLY;
    }

    /**
     * @return string
     */
    public function getStatus()
    {
        return $this->status;
    }

    /**
     * @param string $status
     */
    public function setStatus($status)
    {
        $this->status = $status;
    }

    /**
     * @return int
     */
    public function getDateCreation()
    {
        return $this->dateCreation;
    }

    /**
     * @param int $dateCreation
     */
    public function setDateCreation($dateCreation)
    {
        $this->dateCreation = $dateCreation;
    }

    /**
     * @return bool
     */
    public function canModifyRoster()
    {
        return $this->isOfficer() || $this->isCreator();
    }

    /**
     * @return bool
     */
    public function canAddMemberRoster()
    {
        return $this->isOfficer() || $this->isCreator();
    }

    /**
     * @return bool
     */
    public function canDeleteRoster()
    {
        return $this->isCreator();
    }

    /**
     * @return bool
     */
    public function canLeaveRoster()
    {
        return $this->isCreator() ? false : true;
    }

    /**
     * @param Account $account
     * @return bool
     */
    public function checkData(Account $account)
    {
        $data      = $this->getData();
        $lastCheck = $data['last_check'] ?? 0;
        if (time() - $lastCheck > self::CHECK_DELAY) {
            try {
                $data['characters'] = [];
                if ($account->hasPermission(Account::PERMISSION_CHARACTERS)) {
                    foreach ($account->getCharacters() as $character) {
                        if ($character->getLevel() >= 80) {
                            $char   = [
                                'prof' => $character->getData('profession'),
                                'age'  => $character->getAge(),
                                'name' => $character->getName(),
                            ];
                            $blocks = [];
                            foreach ($character->getEquipmentsBySubtype() as $subtype => $items) {
                                foreach ($items as $item) {
                                    /** @var $item InventorySlot */
                                    $statName = $item->getStatName();
                                    $rarity   = $item->getRarity();
                                    if (empty($statName) || $subtype === Item::SUBTYPE_ARMOR_HELM_AQUATIC) {
                                        continue;
                                    }
                                    $key = $statName . ':' . $rarity;
                                    $cat = Item::TYPE_ARMOR;
                                    if ($item->getType() == Item::TYPE_ARMOR) {
                                        $key  .= ':' . Item::TYPE_ARMOR;
                                        $type = Item::TYPE_ARMOR;
                                    } elseif ($item->getType() == Item::TYPE_WEAPON) {
                                        $key  .= ':' . $subtype;
                                        $type = $subtype;
                                        $cat  = Item::TYPE_WEAPON;
                                    } elseif ($item->getType() == Item::TYPE_TRINKET) {
                                        $key  .= ':' . Item::TYPE_TRINKET;
                                        $type = Item::TYPE_TRINKET;
                                        $cat  = Item::TYPE_TRINKET;
                                    } elseif ($subtype === Character::SLOT_BACKPACK) {
                                        $key  .= ':' . Character::SLOT_BACKPACK;
                                        $type = Character::SLOT_BACKPACK;
                                    } else {
                                        continue;
                                    }
                                    if (!isset($blocks[$key])) {
                                        $blocks[$key] = [
                                            'count'    => 0,
                                            'cat'      => $cat,
                                            'type'     => $type,
                                            'stat'     => $statName,
                                            'rarity'   => $rarity,
                                            'upgrades' => [],
                                        ];
                                    }
                                    $blocks[$key]['count']++;
                                    foreach ($item->getUpgrades() as $upgrade) {
                                        if (!isset($blocks[$key]['upgrades'][$upgrade->getId()])) {
                                            $blocks[$key]['upgrades'][$upgrade->getId()] = 1;
                                        } else {
                                            $blocks[$key]['upgrades'][$upgrade->getId()]++;
                                        }
                                    }
                                }
                            }
                            usort($blocks, function ($a, $b) {
                                return $a['type'] <=> $b['type']
                                    ?: $a['rarity'] <=> $b['rarity']
                                        ?: $a['stat'] <=> $b['stat'];
                            });

                            $char['blocks'] = $blocks;

                            $data['characters'][] = $char;
                        }
                    }
                    usort($data['characters'], function ($a, $b) {
                        return $a['prof'] <=> $b['prof']
                            ?: $a['name'] <=> $b['name'];
                    });
                }
            } catch (\Exception $e) {
            }
            $data['last_check'] = time();
            $this->setData($data);
            return true;
        }
        return false;
    }

    /**
     * @param RaidWeek $week
     * @return bool
     */
    public function canModifyDay(RaidWeek $week)
    {
        return $week->getMember()->getRoster()->getId() == $this->getRoster()->getId() // only for the same roster

src/AppBundle/Resources/views/raidplanner/base.html.twig
{% extends "AppBundle::base.html.twig" %}

{% block title %}
    {{ account.name }} &raquo; {{ 'raidplanner'|trans }}
{% endblock %}

{% block content %}
    <h1>{{ 'raidplanner'|trans }}</h1>

    {% block raidcontent %}
    {% endblock %}

{% endblock %}

src/AppBundle/Resources/views/raidplanner/characters.html.twig
{% extends "AppBundle::raidplanner/base.html.twig" %}

{% set transmap = {
'%_none%' : 'default',
'%_present%' : 'primary',
'%_maybe%' : 'warning',
'%_backup%' : 'info',

'%.backup%': 'raidplanner.status.backup'|trans,
'%.maybe%': 'raidplanner.status.maybe'|trans,
'%.none%': 'raidplanner.status.none'|trans,
'%.present%': 'raidplanner.status.present'|trans
} %}

{% set memberdata = member.getData %}

{% block raidcontent %}

    <div class="panel panel-default">
        <div class="panel-heading">
            <b>{{ member.roster.name }}</b>
            &nbsp; &raquo; &nbsp;
            <b>{{ member.name }}</b>

            <a href="{{ path('raidplanner_detail', {'_code': code, 'id': member.roster.id}) }}"
               class="btn btn-xs btn-primary pull-right" title="{{ 'raidplanner.return'|trans }}">
                <i class="glyphicon glyphicon-chevron-left"></i> {{ 'raidplanner.return'|trans }}
            </a>

        </div>
        <div class="panel-body">

            <table class="table table-hover table-condensed">
                <thead>
                <tr>
                    <th>{{ 'global.name'|trans }}</th>
                    <th>{{ 'global.armor'|trans }}</th>
                    <th>{{ 'global.trinkets'|trans }}</th>
                    <th>{{ 'global.weapons'|trans }}</th>
                </tr>
                </thead>
                <tbody>
                {% for char in memberdata.characters %}
                    <tr>
                        <td>
                            <span class="character-name">
                                <i class="ic-profession-{{ char.prof|lower }}"></i>
                                {{ char.name }}
                            </span>
                            <div class="text-muted"
                                 style="margin-top: 1em; margin-left: 1.8em;">
                                <small>
                                    {{ 'global.age'|trans }}: {{ (char.age/3600)|round }} {{ 'global.hours'|trans|lower }}
                                </small>
                            </div>
                        </td>
                        {% for cat in ['Armor', 'Trinket', 'Weapon'] %}
                            <td>
                                {% for block in char.blocks %}
                                    {% if block.cat == cat %}
                                        <div class="block border rarity-{{ block.rarity }}">
                                            <span title="{{ ('rarity.'~block.rarity)|trans }} - {{ ('stats.'~block.stat)|trans }} - {{ ('itemtype.'~block.type)|trans }}">
                                                <span>{% if block.count > 1 %}x{{ block.count }}{% endif %}</span>
                                                <i class="ic-{{ cat|lower|replace({
                                                    'trinket': 'armor'
                                                }) }}-{{ block.type|lower|replace({
                                                    'armor': 'coat',
                                                    'trinket': 'ring'
                                                }) }}"></i>
                                                <img src="{{ block.stat|imagestat }}"/>
                                            </span>
                                            {% for upid, qty in block.upgrades %}
                                                {% if upgrades[upid] is defined %}
                                                    <span class="upgrade">{% if qty > 1 %}x{{ qty }}{% endif %}</span>
                                                    <span {{ upgrades[upid]|gwlink|raw }}>
                                                        <img src="{{ upgrades[upid]|image }}"/>
                                                    </span>
                                                {% endif %}
                                            {% endfor %}
                                        </div>
                                    {% endif %}
                                {% endfor %}
                            </td>
                        {% endfor %}
                    </tr>
                {% endfor %}
                </tbody>
            </table>

        </div>
    </div>

    <div>

        {% if pagination.pages|length > 1 %}
            <div class="pull-right">

                <div class="btn-group" role="group">
                    {% for p in pagination.pages %}
                        {% if p %}
                            <a href="?page={{ p }}" type="button"
                               class="btn btn-sm btn-{{ p == pagination.page ? 'primary' : 'default' }}">
                                {{ p }}
                            </a>
                        {% else %}
                            <span class="btn btn-sm btn-default">...</span>
                        {% endif %}
                    {% endfor %}
                </div>

            </div>
        {% endif %}

        <a href="{{ path('raidplanner_detail', {'_code': code, 'id': member.roster.id}) }}"
           class="btn btn-sm btn-primary" title="{{ 'raidplanner.return'|trans }}">
            <i class="glyphicon glyphicon-chevron-left"></i> {{ 'raidplanner.return'|trans }}
        </a>

    </div>

    <style>
        td:first-child {
            width: 12em;
            white-space: nowrap;
        }

        td:nth-child(2) {
            width: 15em;
        }

        td:nth-child(3) {
            width: 2em;
        }

        .block {
            display: inline-block;
            margin-right: 1em;
            margin-bottom: .5em;
            border-radius: 3px;
            padding: 0 .2em;
            white-space: nowrap;
        }

        .block * {
            display: inline-block;
            vertical-align: middle;
            margin: 0 !important;
        }

        .block .upgrade {
            padding: 0 .1em 0 .5em;
        }

        .block i {
            font-size: 1.2em;
        }

        .block img {
            max-height: 1.5em;
        }

        .block span img {
            vertical-align: top;
        }
    </style>

{% endblock %}

src/AppBundle/Resources/views/raidplanner/error-access-not-allowed.html.twig
{% extends "AppBundle::raidplanner/base.html.twig" %}

{% block content %}

    {% if lang == 'fr' %}

        <div class="text-danger">
            <p>
                <i class="glyphicon glyphicon-exclamation-sign"></i> <b>Interdit</b>
            </p>
            <p>
                Circulez, il n'y a rien à voir. Vous n'avez pas le droit d'accéder à cette page.
            </p>
        </div>

    {% else %}

        <div class="text-danger">
            <p>
                <i class="glyphicon glyphicon-exclamation-sign"></i> <b>Forbidden</b>
            </p>
            <p>
                There is nothing to see. You have not the right to access this page.
            </p>
        </div>

    {% endif %}

{% endblock %}

src/AppBundle/Resources/views/raidplanner/history.html.twig
{% extends "AppBundle::raidplanner/base.html.twig" %}

{% set transmap = {
'%_none%' : 'link',
'%_absent%' : 'default',
'%_present%' : 'primary',
'%_maybe%' : 'warning',
'%_backup%' : 'info',

'%.backup%': 'raidplanner.status.backup'|trans,
'%.absent%': 'raidplanner.status.absent'|trans,
'%.maybe%': 'raidplanner.status.maybe'|trans,
'%.none%': 'raidplanner.status.none'|trans,
'%.present%': 'raidplanner.status.present'|trans
} %}

{% block raidcontent %}

    <div class="panel panel-default">
        <div class="panel-heading">
            <b>{{ member.roster.name }}</b>

            <a href="{{ path('raidplanner_detail', {'_code': code, 'id': member.roster.id}) }}"
               class="btn btn-xs btn-primary pull-right" title="{{ 'raidplanner.return'|trans }}">
                <i class="glyphicon glyphicon-chevron-left"></i> {{ 'raidplanner.return'|trans }}
            </a>

        </div>
        <div class="panel-body">

            <table class="table table-hover table-condensed">
                <thead>
                <tr>
                    <th>{{ 'raidplanner.date'|trans }}</th>
                    <th>{{ 'raidplanner.type'|trans }}</th>
                    <th>{{ 'raidplanner.description'|trans }}</th>
                </tr>
                </thead>
                <tbody>
                {% for item in history %}
                    <tr>
                        <td>{{ item.datecreation|date('Y-m-d H:i:s') }}</td>
                        <td>{{ ('raidplanner.history.'~item.type)|trans }}</td>
                        <td>{{ ('raidplanner.history.'~item.type~'.text')|trans(item.dataTrans)|replace(transmap)|raw }}</td>
                    </tr>
                {% endfor %}
                </tbody>
            </table>

        </div>
    </div>

    <div>

        {% if pagination.pages|length > 1 %}
            <div class="pull-right">

                <div class="btn-group" role="group">
                    {% for p in pagination.pages %}
                        {% if p %}
                            <a href="?page={{ p }}" type="button"
                               class="btn btn-sm btn-{{ p == pagination.page ? 'primary' : 'default' }}">
                                {{ p }}
                            </a>
                        {% else %}
                            <span class="btn btn-sm btn-default">...</span>
                        {% endif %}
                    {% endfor %}
                </div>

            </div>
        {% endif %}

        <a href="{{ path('raidplanner_detail', {'_code': code, 'id': member.roster.id}) }}"
           class="btn btn-sm btn-primary" title="{{ 'raidplanner.return'|trans }}">
            <i class="glyphicon glyphicon-chevron-left"></i> {{ 'raidplanner.return'|trans }}
        </a>

    </div>

    <style>
        td:first-child {
            width: 12em;
            white-space: nowrap;
        }

        .label-link {
            color: #18bc9c;
        }
    </style>

{% endblock %}

src/AppBundle/Resources/views/raidplanner/list.html.twig
{% extends "AppBundle::raidplanner/base.html.twig" %}

{% block raidcontent %}

    {% if rosters|length %}
        <div class="panel panel-default">
            <div class="panel-body">
                <table class="table table-hover table-condensed">
                    <thead>
                    <tr>
                        <th></th>
                        <th>{{ 'raidplanner.name'|trans }}</th>
                        <th>{{ 'raidplanner.description'|trans }}</th>
                        <th></th>
                    </tr>
                    </thead>
                    <tbody>
                    {% for item in rosters %}
                        <tr>
                            <td>
                                {% if item.member.isCreator %}
                                    <button type="button" class="btn btn-xs btn-danger" disabled
                                            title="{{ 'raidplanner.creator'|trans }}">
                                        <i class="glyphicon glyphicon-user"></i>
                                    </button>
                                {% elseif item.member.isOfficer %}
                                    <button type="button" class="btn btn-xs btn-warning" disabled
                                            title="{{ ('raidplanner.'~(item.member.status ?: 'member'))|trans }}">
                                        <i class="glyphicon glyphicon-user"></i>
                                    </button>
                                {% elseif item.member.isAlly %}
                                    <button type="button" class="btn btn-xs btn-default" disabled
                                            title="{{ ('raidplanner.'~(item.member.status ?: 'member'))|trans }}">
                                        <i class="glyphicon glyphicon-user"></i>
                                    </button>
                                {% else %}
                                    <button type="button" class="btn btn-xs btn-info" disabled
                                            title="{{ ('raidplanner.'~(item.member.status ?: 'member'))|trans }}">
                                        <i class="glyphicon glyphicon-user"></i>
                                    </button>
                                {% endif %}
                            </td>
                            <td>{{ item.roster.name }}</td>
                            <td>{{ item.roster.description }}</td>
                            <td>
                                <a href="{{ path('raidplanner_detail', {'_code': code, 'id': item.roster.id }) }}"
                                   class="btn btn-xs btn-primary">
                                    {{ 'raidplanner.detail'|trans }} <i class="glyphicon glyphicon-chevron-right"></i>
                                </a>
                            </td>
                        </tr>
                    {% endfor %}
                    </tbody>
                </table>
            </div>
        </div>

    {% else %}

        <div class="alert alert-warning" role="alert">
            {{ 'raidplanner.no_rosters'|trans }}
        </div>

    {% endif %}

    <a href="{{ path('raidplanner_create', {'_code': code}) }}" class="btn btn-sm btn-primary">
        <i class="glyphicon glyphicon-plus"></i> {{ 'raidplanner.create'|trans }}
    </a>

    <style>
        tr td:first-child {
            width: 2em;
        }

        tr td:nth-child(2) {
            width: 25%;
        }

        tr td:last-child {
            text-align: right;
        }

        .btn.disabled, .btn[disabled] {
            cursor: default;
        }
    </style>

{% endblock %}